<template>
  <div ref="el" class="Observer">
    <slot> </slot>
  </div>
</template>

<script lang="ts">
import { defineComponent, onMounted, onUnmounted, ref } from 'vue'

export default defineComponent({
  emits: ['intersect'],
  props: {
    options: Object,
  },

  setup(props, context) {
    let observer: IntersectionObserver | null = null
    const el = ref<HTMLElement | null>(null)

    onMounted(() => {
      const options = props.options || {}
      if (el.value) {
        observer = new IntersectionObserver(([entry]) => {
          if (entry) context.emit('intersect', entry.isIntersecting)
        }, options)

        observer.observe(el.value)
      }
    })

    onUnmounted(() => {
      if (observer) observer.disconnect()
    })

    return {
      el,
    }
  },
})
</script>
<style lang="scss" scoped>
.Observer {
  min-height: 1px;
}
</style>
